
#ifndef __IMAGER_FINDCLUST_H__
#define __IMAGER_FINDCLUST_H__


/* The non-GUI core routine */
void clust_thresh (image_type* img, int r, int g, int b, float t, int thrtype);
int findclust_2d (image_type* img, int slice, int maxclust, int f8neigh, int minsize, int labelopts, cluster_type* list);
int findclust_3d (image_type* img, int maxclust, int f8neigh, int minsize, int labelopts, cluster_type* list);

/* Individual functions of the new algorithm */

int new_pass1_2d (image_type* src, image_type* dest, int slice, char f8neigh, int minsize);
void new_pass2 (image_type* dest, int max, cluster_type* list, int f8ngh, int labelopts);

/* Reporting functions */

void clust_measure_intens (image_type *img, image_type *clusterimg, cluster_type *list, int clustnum);
void clust_report_tabular (cluster_type* list, int clustnum, int is_3d, int ext_rpt);

/* Cluster counter to obtain nc(t) and nc_max */

int clust_clustercount (image_type* img, float thresh, int numsamples, int minsize, int maxclust, int lowdens);

/* The GUI-based caller */

void clustfind ();
void clustcnt ();


#endif
