



/* graphdsp.h -- display simple functions y = f(x) */


#ifndef __IMAGER_GRAPHDSP_H
#define __IMAGER_GRAPHDSP_H



#include "defs.h"


/* Define plot options. These can be OR'ed, so we use
	#define with bit-shifted logical Ones. */


#define PLOT_LOG_X			(1<<0)
#define PLOT_LOG_Y			(1<<1)
#define PLOT_POINTS			(1<<2)
#define PLOT_BARS			(1<<3)
#define PLOT_BARS_STAGGERED	(1<<4)


/* Axis labels and title -- we need to be able to set them elsewhere */

gchar yaxislabel[512];
gchar xaxislabel[512];
gchar chart_title[512];


rgbtriplet colortable[16];

void minimax(double* pmin, double* pmax);
double calcstep (double min, double max, int numticks);

void Frame(GtkWidget* draw, float* xdata, float* ydata, int datapoints, int datasets);
void DrawData(GtkWidget* draw, float* xdata, float* ydata, int datapoints, int datasets);
void g_window_set_title (const char *s);

void send_to_gnuplot (float* xdata, float* ydata, int datapoints, int datasets, unsigned short plotopts);

void graphme (float* xdata, float* ydata, int numpts, gchar *xlabel, gchar *ylabel, gchar *title, unsigned short plotopts);
void multi_graphme (float* xdata, float* ydata, int numpts, int datasets, gchar *xlabel, gchar *ylabel, gchar *title, unsigned short plotopts);
void graphme_d (double* xdata, double* ydata, int numpts, gchar *xlabel, gchar *ylabel, gchar *title, unsigned short plotopts);
void multi_graphme_d (double* xdata, double* ydata, int numpts, int datasets, gchar *xlabel, gchar *ylabel, gchar *title, unsigned short plotopts);



#endif

