

/* Module: Wavelets filters.
	Please note that this module is highly experimental.


*/

/*		MODULE FOR CRYSTAL IMAGE 0.85 BETA
		This program is copyrighted material.
		(C) 2002-2010 by Mark A. Haidekker, all rights reserved.
		
		This program is free software: you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation, either version 3 of the License, or
		(at your option) any later version.

		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE:

		THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
		APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
		HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
		OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
		THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
		PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
		IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
		ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

		IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
		WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
		THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
		GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
		USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
		DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
		PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
		EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
		SUCH DAMAGES.

		For the full text of the license, please see the file COPYING
		in the project's main directory, or read it on the Web at
		http://www.gnu.org/copyleft/gpl.html

 */




#include <gtk/gtk.h>
#include <gdk/gdk.h>

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>



#include "gtkhelpers.h"
#include "wvlt_core.h"
#include "wvlt_filt.h"











/*+**********************************+******************+

  ####    #    #   #*#
 #    #   #    #    #
 #        #    #    #
 #   ##   #    #    #
 #    #   #    #    #
 #    #   #    #    #
  ####     ####    #*#

*/




wavefilt wfilt;	
int wfunction, wshrinkfunc;
GtkAdjustment *wvlt_decomp_adj, *wvlt_tmult_adj;




void on_wvlt_filt_ok_clicked  (GtkButton *button, gpointer user_data)
{
int decomp_level;
WAVELET_TYPE wtype;
float tmult;
char msg[512];


	undo_nexus (&mainimg);

	decomp_level = wvlt_decomp_adj->value;
	tmult = wvlt_tmult_adj->value;

	wtype = set_subband (wfunction);
	if (wtype!=W_NULL) 
	{
		sprintf (msg, "Denoised: %s, ", wvlt_used);
		if ((wshrinkfunc>>1) ==0) strcat (msg, "VisuShrink ");
		else if ((wshrinkfunc>>1) ==1) strcat (msg, "BayesShrink ");
		else if ((wshrinkfunc>>1) ==1) strcat (msg, "SUREShrink ");
		else if ((wshrinkfunc>>1) ==1) strcat (msg, "GCV ");
		if (wshrinkfunc & 0x01) strcat (msg, "(hard)");
		else strcat (msg, "(soft)");

		wfilt = wavelet_prepare (wtype);
		dwt_2d (&mainimg, W_FORWARD, decomp_level, wfilt, *subband);
		wavelet_shrink (&mainimg, decomp_level, wshrinkfunc, tmult);
		dwt_2d (&mainimg, W_INVERSE, decomp_level, wfilt, *subband);
	}
	else
		strcpy (msg, "Error: NULL wavelet filter. How did this happen?");

	make_imlib_buffer_from_main_image (cur_slice);
	redraw(0);
	statusbar_display (msg);

	gtk_widget_destroy (GTK_WIDGET(user_data));
}




void wvlt_filt_shrink_menu (GtkWidget *widget, gpointer user_data)
{

	wshrinkfunc = *(int*) user_data;
	dp (2, "Changed shrinking threshold function to %d\n", wshrinkfunc);
	
}


void wvlt_filt_type_menu (GtkWidget *widget, gpointer user_data)
{

	wfunction = *(int*) user_data;
	dp (2, "Changed wavelet to %d\n", wfunction);
	
}

void on_wvlt_filt_cancel_clicked  (GtkButton *button, gpointer user_data)
{

	gtk_widget_destroy (GTK_WIDGET(user_data));
}







void create_wvlt_filt_window (image_type *img)
{
  GtkWidget *wvlt_window;
  GtkWidget *vbox1, *hbox1, *wvlt_table;
  GtkWidget *wvlt_label2;
  GtkWidget *wvlt_label3;
  GtkWidget *hsep1;
  GtkWidget *wvlt_funcmenu;
  GtkWidget *wvlt_shrinkmenu;
  GtkWidget *wvlt_typemenu;
  GtkWidget *wvlt_label4, *wvlt_label1, *wvlt_label5;
  GtkWidget *wvlt_tmult;
  GtkWidget *wvlt_okbutton;
  GtkWidget *wvlt_showbutton;
  GtkWidget *wvlt_testbutton;
  GtkWidget *wvlt_cancelbutton;
  GtkWidget *wvlt_typemenu_menu;
  GtkWidget *wvlt_funcmenu_menu;
  GtkWidget *wvlt_shrinkmenu_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *wvlt_decomp;
  GtkTooltips *tt_wvltcancel, *tt_wvltdecomp, *tt_wvltfn, *tt_wvltok, *tt_wvltshow, *tt_wvltshrink, *tt_wvlttest, *tt_wvlttmult, *tt_wvlttype;

  int y;


	wvlt_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data (GTK_OBJECT (wvlt_window), "wvlt_window", wvlt_window);
	gtk_window_set_title (GTK_WINDOW (wvlt_window), "Wavelet-Based Filters");

	vbox1 = vbox_in_window (wvlt_window,"vbox1"); 
	wvlt_table = MakeTable (wvlt_window, vbox1, "table1", 2,6);

	y=0;
	wvlt_label1 = MakeLabel (wvlt_window,wvlt_table,"Wavelet type","wvlt_label1",0,y);
	wvlt_typemenu = Make_Optionmenu (wvlt_window, wvlt_table, "wvlt_typemenu", 1,y);
	wvlt_typemenu_menu = gtk_menu_new ();
	glade_menuitem = Option_menuitem (wvlt_typemenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_type_menu), "Haar", (gpointer) &menuopt0);
	glade_menuitem = Option_menuitem (wvlt_typemenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_type_menu), "Daubechies-4", (gpointer) &menuopt1);
	glade_menuitem = Option_menuitem (wvlt_typemenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_type_menu), "Daubechies-8", (gpointer) &menuopt2);
	glade_menuitem = Option_menuitem (wvlt_typemenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_type_menu), "Daubechies-12", (gpointer) &menuopt3);
	glade_menuitem = Option_menuitem (wvlt_typemenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_type_menu), "Daubechies-20", (gpointer) &menuopt4);
	glade_menuitem = Option_menuitem (wvlt_typemenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_type_menu), "Coiflet-6", (gpointer) &menuopt5);
	glade_menuitem = Option_menuitem (wvlt_typemenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_type_menu), "Coiflet12", (gpointer) &menuopt6);
	glade_menuitem = Option_menuitem (wvlt_typemenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_type_menu), "Symlet-4", (gpointer) &menuopt7);
	glade_menuitem = Option_menuitem (wvlt_typemenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_type_menu), "Symlet-8", (gpointer) &menuopt8);
	glade_menuitem = Option_menuitem (wvlt_typemenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_type_menu), "Symlet-12", (gpointer) &menuopt9);
	gtk_option_menu_set_menu (GTK_OPTION_MENU (wvlt_typemenu), wvlt_typemenu_menu);
	gtk_option_menu_set_history (GTK_OPTION_MENU (wvlt_typemenu), 0); wfunction=0;
	gtk_container_set_border_width (GTK_CONTAINER (wvlt_typemenu), 5);
	tt_wvlttype = gtk_tooltips_new ();
	gtk_tooltips_set_tip (tt_wvlttype, wvlt_typemenu, "Choose mother wavelet", NULL);

	y++;
	wvlt_label2 = MakeLabel (wvlt_window,wvlt_table,"Decomposition level","wvlt_label2",0,y);
	wvlt_decomp_adj = GTK_ADJUSTMENT(gtk_adjustment_new (3, 1, 10, 1, 1, 0));
	wvlt_decomp = MakeHScale (wvlt_decomp_adj, wvlt_window, wvlt_table,"wvlt_decomp", 1,y);
	gtk_scale_set_digits (GTK_SCALE (wvlt_decomp), 0);
	tt_wvltdecomp = gtk_tooltips_new ();
	gtk_tooltips_set_tip (tt_wvltdecomp, wvlt_decomp, "Maximum dyadic decomposition levels", NULL);

	y++;
	wvlt_label4 = MakeLabel (wvlt_window,wvlt_table,"Shrink Function","wvlt_label4",0,y);
	wvlt_shrinkmenu = Make_Optionmenu (wvlt_window, wvlt_table, "wvlt_shrinkmenu", 1,y);
	wvlt_shrinkmenu_menu = gtk_menu_new ();
	glade_menuitem = Option_menuitem (wvlt_shrinkmenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_shrink_menu), "Universal/VisuShrink (soft)", (gpointer) &menuopt0);
	glade_menuitem = Option_menuitem (wvlt_shrinkmenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_shrink_menu), "Universal/VisuShrink (hard)", (gpointer) &menuopt1);
	glade_menuitem = Option_menuitem (wvlt_shrinkmenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_shrink_menu), "BayesShrink (soft)", (gpointer) &menuopt2);
	glade_menuitem = Option_menuitem (wvlt_shrinkmenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_shrink_menu), "BayesShrink (hard)", (gpointer) &menuopt3);
	glade_menuitem = Option_menuitem (wvlt_shrinkmenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_shrink_menu), "SUREShrink (soft)", (gpointer) &menuopt4);
	glade_menuitem = Option_menuitem (wvlt_shrinkmenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_shrink_menu), "SUREShrink (hard)", (gpointer) &menuopt5);
	glade_menuitem = Option_menuitem (wvlt_shrinkmenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_shrink_menu), "GCVT (soft)", (gpointer) &menuopt6);
	glade_menuitem = Option_menuitem (wvlt_shrinkmenu_menu, GTK_SIGNAL_FUNC(wvlt_filt_shrink_menu), "GCVT (hard)", (gpointer) &menuopt7);
	gtk_option_menu_set_menu (GTK_OPTION_MENU (wvlt_shrinkmenu), wvlt_shrinkmenu_menu);
	gtk_option_menu_set_history (GTK_OPTION_MENU (wvlt_shrinkmenu), 0);
	gtk_container_set_border_width (GTK_CONTAINER (wvlt_shrinkmenu), 5);
	gtk_widget_show (wvlt_label4); gtk_widget_show (wvlt_shrinkmenu);
	tt_wvltshrink = gtk_tooltips_new ();
	gtk_tooltips_set_tip (tt_wvltshrink, wvlt_shrinkmenu, "Wavelet shrinking operation or threshold operation", NULL);

	y++;
	wvlt_label5 = MakeLabel (wvlt_window,wvlt_table,"Threshold Multiplier","wvlt_label5",0,y);
	wvlt_tmult_adj = GTK_ADJUSTMENT(gtk_adjustment_new (1, 0, 5, 0.1, 1, 0));
	wvlt_tmult = MakeHScale (wvlt_tmult_adj, wvlt_window, wvlt_table,"wvlt_tmult", 1,y);
	gtk_scale_set_digits (GTK_SCALE (wvlt_tmult), 1);
	gtk_widget_show (wvlt_label5); gtk_widget_show (wvlt_tmult);
	tt_wvlttmult = gtk_tooltips_new ();
	gtk_tooltips_set_tip (tt_wvlttmult, wvlt_tmult, "Factor to multiply the shrinking theshold with.\nHigher = stronger shrinking.", NULL);


	hsep1 = MakeHsep (wvlt_window, vbox1, "hsep3", -1,-1);
	hbox1 = hbox_in_window (wvlt_window, vbox1, "wvlt_hbox");

	wvlt_okbutton = Button_in_table (wvlt_window, hbox1, "OK", "wvlt_okbutton",-1,-1, NULL);
	wvlt_cancelbutton = Button_in_table (wvlt_window, hbox1, "CANCEL", "wvlt_cancelbutton",-1,-1,NULL);
	tt_wvltok = gtk_tooltips_new ();
	gtk_tooltips_set_tip (tt_wvltok, wvlt_okbutton, "Execute the selected operation", NULL);
	tt_wvltcancel = gtk_tooltips_new ();
	gtk_tooltips_set_tip (tt_wvltcancel, wvlt_cancelbutton, "Abort operation, close window.", NULL);

	gtk_signal_connect (GTK_OBJECT (wvlt_okbutton), "clicked", GTK_SIGNAL_FUNC (on_wvlt_filt_ok_clicked), wvlt_window);
	gtk_signal_connect (GTK_OBJECT (wvlt_cancelbutton), "clicked", GTK_SIGNAL_FUNC (on_wvlt_filt_cancel_clicked), wvlt_window);
	gtk_signal_connect (GTK_OBJECT (wvlt_window), "destroy", GTK_SIGNAL_FUNC (on_wvlt_filt_cancel_clicked), wvlt_window);


	gtk_widget_show (wvlt_window); 

}


void wavelet_filter_main ()
{

	create_wvlt_filt_window (&mainimg);

}



/* This is called by the macro interpreter */

void wvdenoise_macro_driver (image_type *img, int wfunction, int shrinkfunc, int decomp, float tmult)
{
WAVELET_TYPE wtype;
wavefilt wfilter;


	wtype = set_subband (wfunction);
	if (wtype!=W_NULL) 
	{
		wfilter = wavelet_prepare (wtype);
		dwt_2d (img, W_FORWARD, decomp, wfilter, *subband);
		wavelet_shrink (img, decomp, shrinkfunc, tmult);
		dwt_2d (img, W_INVERSE, decomp, wfilter, *subband);
	}


}



/********************************************************************************/
